function c = pvsample(b, t, hop)
% c = pvsample(b, t, hop)         
%     b  ;
%     t    ,   b.    t, 
%           b, 
%          b;
%         c   ,  
%              .
%     hop    ,   N/2,  N   ,
%       b  N/2+1 . hop    '' 
%        .
%     : t       ,   0.1 -  90%
%        b,  10% .

if nargin < 3
  hop = 0;
end

[rows,cols] = size(b);

N = 2*(rows-1);

if hop == 0
  % default value
  hop = N/2;
end

%   
c = zeros(rows, length(t));

%      
dphi = zeros(1,N/2+1);
dphi(2:(1 + N/2)) = (2*pi*hop)./(N./(1:(N/2)));

%  
%        
%     1:1
ph = angle(b(:,1));

%  ''    b   
%  **   (.. 1*b(:,cols)+0*b(:,cols+1))
b = [b,zeros(rows,1)];

ocol = 1;
for tt = t
  %     b
  bcols = b(:,floor(tt)+[1 2]);
  tf = tt - floor(tt);
  bmag = (1-tf)*abs(bcols(:,1)) + tf*(abs(bcols(:,2)));
  %   
  dp = angle(bcols(:,2)) - angle(bcols(:,1)) - dphi';
  %    pi:pi
  dp = dp - 2 * pi * round(dp/(2*pi));
  %  
  c(:,ocol) = bmag .* exp(j*ph);
  %  ,    
  ph = ph + dphi' + dp;
  ocol = ocol+1;
end
